/*
 *   Copyright 2014-2023 IHE International
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.2.4-2 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2012.12.25 at 01:02:08 PM CET 
//

package net.ihe.gazelle.audit.message.desc;

import org.jboss.seam.annotations.Name;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.*;
import java.io.Serializable;

/**
 * Java class for ActiveParticipantDescription complex type.
 * The following schema fragment specifies the expected content contained within
 * this class.
 * <pre>
 * &lt;complexType name=&quot;ActiveParticipantDescription&quot;&gt;
 *   &lt;complexContent&gt;
 *     &lt;restriction base=&quot;{http://www.w3.org/2001/XMLSchema}anyType&quot;&gt;
 *       &lt;sequence&gt;
 *         &lt;element name=&quot;UserID&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *         &lt;element name=&quot;AlternativeUserID&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *         &lt;element name=&quot;UserName&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *         &lt;element name=&quot;UserIsRequestor&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *         &lt;element name=&quot;RoleIDCode&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *         &lt;element name=&quot;NetworkAccessPointTypeCode&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *         &lt;element name=&quot;NetworkAccessPointID&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *       &lt;/sequence&gt;
 *       &lt;attribute name=&quot;cardinality&quot; type=&quot;{}Cardinality&quot; default=&quot;0..1&quot; /&gt;
 *       &lt;attribute name=&quot;name&quot; use=&quot;required&quot; type=&quot;{http://www.w3.org/2001/XMLSchema}string&quot; /&gt;
 *     &lt;/restriction&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ActiveParticipantDescription", propOrder = {"userID",
        "alternativeUserID", "userName", "userIsRequestor", "roleIDCode",
        "networkAccessPointTypeCode", "networkAccessPointID", "mediaIdentifier"})
@Entity
@Name("activeParticipantDescription")
@Table(name = "am_active_participant_description", schema = "public")
@SequenceGenerator(name = "am_active_participant_description_sequence", sequenceName = "am_active_participant_description_id_seq", allocationSize = 1)
public class ActiveParticipantDescription implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlTransient
    @Id
    @GeneratedValue(generator = "am_active_participant_description_sequence", strategy = GenerationType.SEQUENCE)
    @NotNull
    @Column(name = "id")
    private Integer id;

    @XmlElement(name = "UserID", required = true)
    @ManyToOne(cascade = {CascadeType.ALL})
    @JoinColumn(name = "userID_id")
    protected ElementDescription userID;

    @XmlElement(name = "AlternativeUserID", required = true)
    @ManyToOne(cascade = {CascadeType.ALL})
    @JoinColumn(name = "alternativeUserID_id")
    protected ElementDescription alternativeUserID;

    @XmlElement(name = "UserName", required = true)
    @ManyToOne(cascade = {CascadeType.ALL})
    @JoinColumn(name = "userName_id")
    protected ElementDescription userName;

    @XmlElement(name = "UserIsRequestor", required = true)
    @ManyToOne(cascade = {CascadeType.ALL})
    @JoinColumn(name = "userIsRequestor_id")
    protected ElementDescription userIsRequestor;

    @XmlElement(name = "RoleIDCode", required = true)
    @ManyToOne(cascade = {CascadeType.ALL})
    @JoinColumn(name = "roleIDCode_id")
    protected ElementDescription roleIDCode;

    @XmlElement(name = "NetworkAccessPointTypeCode", required = true)
    @ManyToOne(cascade = {CascadeType.ALL})
    @JoinColumn(name = "networkAccessPointTypeCode_id")
    protected ElementDescription networkAccessPointTypeCode;

    @XmlElement(name = "NetworkAccessPointID", required = true)
    @ManyToOne(cascade = {CascadeType.ALL})
    @JoinColumn(name = "networkAccessPointID_id")
    protected ElementDescription networkAccessPointID;

    @XmlElement(name = "MediaIdentifier", required = true)
    @ManyToOne(cascade = {CascadeType.ALL})
    @JoinColumn(name = "mediaIdentifier_id")
    protected ElementDescription mediaIdentifier;

    @XmlAttribute(name = "min")
    protected String min;

    @XmlAttribute(name = "max")
    protected String max;

    @XmlAttribute(name = "name", required = true)
    protected String name;

    @XmlAttribute(name = "distinguisher", required = true)
    protected String distinguisher;

    public ElementDescription getMediaIdentifier() {
        return mediaIdentifier;
    }

    public void setMediaIdentifier(ElementDescription mediaIdentifier) {
        this.mediaIdentifier = mediaIdentifier;
    }

    public String getDistinguisher() {
        return distinguisher;
    }

    public void setDistinguisher(String distinguisher) {
        this.distinguisher = distinguisher;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((alternativeUserID == null) ? 0 : alternativeUserID.hashCode());
        result = prime * result + ((mediaIdentifier == null) ? 0 : mediaIdentifier.hashCode());
        result = prime * result + ((name == null) ? 0 : name.hashCode());
        result = prime * result + ((networkAccessPointID == null) ? 0 : networkAccessPointID.hashCode());
        result = prime * result + ((networkAccessPointTypeCode == null) ? 0 : networkAccessPointTypeCode.hashCode());
        result = prime * result + ((roleIDCode == null) ? 0 : roleIDCode.hashCode());
        result = prime * result + ((userID == null) ? 0 : userID.hashCode());
        result = prime * result + ((userIsRequestor == null) ? 0 : userIsRequestor.hashCode());
        result = prime * result + ((userName == null) ? 0 : userName.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        ActiveParticipantDescription other = (ActiveParticipantDescription) obj;
        if (alternativeUserID == null) {
            if (other.alternativeUserID != null) {
                return false;
            }
        } else if (!alternativeUserID.equals(other.alternativeUserID)) {
            return false;
        }
        if (mediaIdentifier == null) {
            if (other.mediaIdentifier != null) {
                return false;
            }
        } else if (!mediaIdentifier.equals(other.mediaIdentifier)) {
            return false;
        }
        if (name == null) {
            if (other.name != null) {
                return false;
            }
        } else if (!name.equals(other.name)) {
            return false;
        }
        if (networkAccessPointID == null) {
            if (other.networkAccessPointID != null) {
                return false;
            }
        } else if (!networkAccessPointID.equals(other.networkAccessPointID)) {
            return false;
        }
        if (networkAccessPointTypeCode == null) {
            if (other.networkAccessPointTypeCode != null) {
                return false;
            }
        } else if (!networkAccessPointTypeCode.equals(other.networkAccessPointTypeCode)) {
            return false;
        }
        if (roleIDCode == null) {
            if (other.roleIDCode != null) {
                return false;
            }
        } else if (!roleIDCode.equals(other.roleIDCode)) {
            return false;
        }
        if (userID == null) {
            if (other.userID != null) {
                return false;
            }
        } else if (!userID.equals(other.userID)) {
            return false;
        }
        if (userIsRequestor == null) {
            if (other.userIsRequestor != null) {
                return false;
            }
        } else if (!userIsRequestor.equals(other.userIsRequestor)) {
            return false;
        }
        if (userName == null) {
            if (other.userName != null) {
                return false;
            }
        } else if (!userName.equals(other.userName)) {
            return false;
        }
        return true;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    /**
     * Gets the value of the userID property.
     *
     * @return possible object is {@link ElementDescription }
     */
    public ElementDescription getUserID() {
        return userID;
    }

    /**
     * Sets the value of the userID property.
     *
     * @param value allowed object is {@link ElementDescription }
     */
    public void setUserID(ElementDescription value) {
        this.userID = value;
    }

    /**
     * Gets the value of the alternativeUserID property.
     *
     * @return possible object is {@link ElementDescription }
     */
    public ElementDescription getAlternativeUserID() {
        return alternativeUserID;
    }

    /**
     * Sets the value of the alternativeUserID property.
     *
     * @param value allowed object is {@link ElementDescription }
     */
    public void setAlternativeUserID(ElementDescription value) {
        this.alternativeUserID = value;
    }

    /**
     * Gets the value of the userName property.
     *
     * @return possible object is {@link ElementDescription }
     */
    public ElementDescription getUserName() {
        return userName;
    }

    /**
     * Sets the value of the userName property.
     *
     * @param value allowed object is {@link ElementDescription }
     */
    public void setUserName(ElementDescription value) {
        this.userName = value;
    }

    /**
     * Gets the value of the userIsRequestor property.
     *
     * @return possible object is {@link ElementDescription }
     */
    public ElementDescription getUserIsRequestor() {
        return userIsRequestor;
    }

    /**
     * Sets the value of the userIsRequestor property.
     *
     * @param value allowed object is {@link ElementDescription }
     */
    public void setUserIsRequestor(ElementDescription value) {
        this.userIsRequestor = value;
    }

    /**
     * Gets the value of the roleIDCode property.
     *
     * @return possible object is {@link ElementDescription }
     */
    public ElementDescription getRoleIDCode() {
        return roleIDCode;
    }

    /**
     * Sets the value of the roleIDCode property.
     *
     * @param value allowed object is {@link ElementDescription }
     */
    public void setRoleIDCode(ElementDescription value) {
        this.roleIDCode = value;
    }

    /**
     * Gets the value of the networkAccessPointTypeCode property.
     *
     * @return possible object is {@link ElementDescription }
     */
    public ElementDescription getNetworkAccessPointTypeCode() {
        return networkAccessPointTypeCode;
    }

    /**
     * Sets the value of the networkAccessPointTypeCode property.
     *
     * @param value allowed object is {@link ElementDescription }
     */
    public void setNetworkAccessPointTypeCode(ElementDescription value) {
        this.networkAccessPointTypeCode = value;
    }

    /**
     * Gets the value of the networkAccessPointID property.
     *
     * @return possible object is {@link ElementDescription }
     */
    public ElementDescription getNetworkAccessPointID() {
        return networkAccessPointID;
    }

    /**
     * Sets the value of the networkAccessPointID property.
     *
     * @param value allowed object is {@link ElementDescription }
     */
    public void setNetworkAccessPointID(ElementDescription value) {
        this.networkAccessPointID = value;
    }

    /**
     * Gets the value of the name property.
     *
     * @return possible object is {@link String }
     */
    public String getName() {
        return name;
    }

    /**
     * Sets the value of the name property.
     *
     * @param value allowed object is {@link String }
     */
    public void setName(String value) {
        this.name = value;
    }

    public String getMin() {
        if (min == null) {
            min = "0";
        }
        return min;
    }

    public void setMin(String min) {
        if (min == null) {
            min = "0";
        }
        this.min = min;
    }

    public String getMax() {
        if (max == null) {
            max = "*";
        }
        return max;
    }

    public void setMax(String max) {
        if (max == null) {
            max = "*";
        }
        this.max = max;
    }

}
